//WaterSimDCDC Regional Water Demand and Supply Model Version 5.0

//       This is the C# Utilities file for the C# interface to the WaterSim_DCDC FORTRAN dll.

//       Copyright (C) 2011 , The Arizona Board of Regents
//              on behalf of Arizona State University

//       All rights reserved.

//       Developed by the Decision Center for a Desert City
//       Lead Model Development - David A. Sampson <david.a.sampson@asu.edu>


//       This program is free software: you can redistribute it and/or modify
//       it under the terms of the GNU General Public License version 3 as published by
//       the Free Software Foundation.

//       This program is distributed in the hope that it will be useful,
//       but WITHOUT ANY WARRANTY; without even the implied warranty of
//       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//       GNU General Public License for more details.

//       You should have received a copy of the GNU General Public License
//       along with this program.  If not, please see <http://www.gnu.org/licenses/>.
//
// =====================================================================================
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;       // for DllImport

//CHANGED QUAY was WaterSim
namespace WaterSimDCDC
{
    internal static class API
    {
        private const int numModeledProviders = 33;
        //const int defaultReclaimedToOutput = 10; // this is trouble

        #region providerNamedConstants
       internal const int ad = (int)providers.Adaman_Mutual;
       internal const int wt = (int)providers.White_Tanks;
       internal const int pv = (int)providers.Paradise_Valley;
       internal const int su = (int)providers.Sun_City;
       internal const int sw = (int)providers.Sun_City_West;
       internal const int av = (int)providers.Avondale;
       internal const int be = (int)providers.Berneil;
       internal const int bu = (int)providers.Buckeye;
       internal const int cf = (int)providers.Carefree;
       internal const int cc = (int)providers.Cave_Creek;
       internal const int ch = (int)providers.Chandler;
       internal const int cp = (int)providers.Chaparral_City;
       internal const int sp = (int)providers.Surprise;
       internal const int cu = (int)providers.Clearwater_Utilities;
       internal const int dh = (int)providers.Desert_Hills;
       internal const int em = (int)providers.El_Mirage;
       internal const int gi = (int)providers.Gilbert;
       internal const int gl = (int)providers.Glendale;
       internal const int go = (int)providers.Goodyear;
       internal const int lp = (int)providers.Litchfield_Park;
       internal const int me = (int)providers.Mesa;
       internal const int pe = (int)providers.Peoria;
       internal const int ph = (int)providers.Phoenix;
       internal const int qk = (int)providers.Queen_Creek;
       internal const int rg = (int)providers.Rigby;
       internal const int rv = (int)providers.Rio_Verde;
       internal const int ry = (int)providers.Rose_Valley;
       internal const int sc = (int)providers.Scottsdale;
       internal const int sr = (int)providers.Sunrise;
       internal const int te = (int)providers.Tempe;
       internal const int to = (int)providers.Tolleson;
       internal const int vu = (int)providers.Valley_Utilities;
       internal const int we = (int)providers.West_End;
        //
        #endregion

        #region parmsInit

        internal static int[] set_parmWWtoRWWTPpct    = new int[numModeledProviders] {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
        internal static int[] set_parmReclaimedWWtoROpct      = new int[numModeledProviders] {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
        internal static int[] set_parmWWtoEffluentPct = new int[numModeledProviders] {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};

        internal static int[] set_parmEffluentToVadosePct= new int[numModeledProviders] {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
        internal static int[] set_parmEffluentToPowerPlantPct = new int[numModeledProviders] { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1};

        internal static int[] set_parmReclaimedToVadosePct = new int[numModeledProviders] {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
        internal static int[] set_parmReclaimedToDirectInjectPct =  new int[numModeledProviders] {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
        internal static int[] set_parmReclaimedToOutputPct    = new int[numModeledProviders] {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
        internal static int[] set_parmReclaimedToInputPct = new int[numModeledProviders] { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 };

        internal static int[] set_parmROReclaimedToOutputPct  = new int[numModeledProviders] {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};

        internal static int[] set_parmSurfaceWaterToWbankPct = new int[numModeledProviders] {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
        internal static int[] set_parmSurfaceWaterToWbankAmt = new int[numModeledProviders] { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1};
        internal static int[] set_parmSurfaceWaterToVadoseAmt = new int[numModeledProviders] { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1};
        internal static int[] set_parmWaterSupplyToDirectInjectAmt = new int[numModeledProviders] { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1};



        internal static int[] set_parmOutdoorWaterUsePct = new int[numModeledProviders] {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
        internal static int[] set_parmReclaimedOutdoorUsePct = new int[numModeledProviders] {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};

        internal static int[] set_parmWaterSupplyToResidentialPct = new int[numModeledProviders] {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
        internal static int[] set_parmWaterSupplyToCIOpct = new int[numModeledProviders] {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};

        internal static int[] set_parmGroundwaterToGWTPlantPct = new int[numModeledProviders] {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
        // New since passing to Ray - 07.07.11 das
        internal static bool set_parmIncludeMeteo = new bool();
        internal static int[] set_TimeLagVadoseYears = new int[numModeledProviders] { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,-1};
        internal static int[] set_ProviderGPCD = new int[numModeledProviders] { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1};
        internal static int[] set_ProviderPopGrowthRateAdjustPct = new int[numModeledProviders] { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 };
        internal static int[] set_WaterBankingOption = new int[numModeledProviders] { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 };

        #endregion

        #region outputs

        #endregion
        //
        // CHANGED QUAY was WaterSim.WaterSimU _ws
        internal static void parms(WaterSimU _ws)
        {
            //
            _ws.get_parmWWtoRWWTPpct = set_parmWWtoRWWTPpct;
            _ws.get_parmReclaimedWWtoROpct = set_parmReclaimedWWtoROpct;
            _ws.get_parmWWtoEffluentPct = set_parmWWtoEffluentPct;
            _ws.get_parmReclaimedToInputPct = set_parmReclaimedToInputPct;

            _ws.get_parmROReclaimedToOutputPct = set_parmROReclaimedToOutputPct;
            _ws.get_parmSurfaceWaterToWbankPct = set_parmSurfaceWaterToWbankPct;
            _ws.get_parmSurfaceWaterToWBankAmt = set_parmSurfaceWaterToWbankAmt;

            _ws.get_parmSurfaceWaterToVadoseAmt = set_parmSurfaceWaterToVadoseAmt;
            _ws.get_parmWaterSupplyToDirectInjectAmt = set_parmWaterSupplyToDirectInjectAmt;
            //
            _ws.get_parmOutdoorWaterUsePct      = set_parmOutdoorWaterUsePct;
            _ws.get_parmReclaimedOutdoorUsePct  = set_parmReclaimedOutdoorUsePct;
            _ws.get_parmGroundwaterToGWTPlantPct = set_parmGroundwaterToGWTPlantPct;
            //
            // Other Provider variables
            _ws.get_parmIncludeMeteorology = set_parmIncludeMeteo;
            _ws.TimeLagVadoseYears = set_TimeLagVadoseYears;
            _ws.get_ProviderGPCD = set_ProviderGPCD;
            _ws.get_ProviderPopGrowthRateAdjustPct = set_ProviderPopGrowthRateAdjustPct;
            _ws.get_WaterBankingOption = set_WaterBankingOption;
            // Other CityModel or Legacy variables
            _ws.DemandPercent = 100;
            //
            RangeCheckEffluent(_ws);
            RangeCheckReclaimed(_ws);
            RangeCheckWaterSupply(_ws);
            //
        }
        //
        #region RangeCheck
        // CHANGED QUAY was WaterSim.WaterSimU _ws

        internal static void RangeCheckReclaimed(WaterSimU _ws)
        {
            string tag = "Reclaimed parameters-";
            // CHANGED QUAY was WaterSim.WaterSimU _ws

            int mydefault=WaterSimU.ReclaimedToOutputPct;
            int ReclaimedToOutput;
            for (int num = 0; num < numModeledProviders; ++num)
            {
                ReclaimedToOutput=set_parmReclaimedToOutputPct[num];
                RangeCheckThree_oneDefault(num, set_parmReclaimedToOutputPct,set_parmReclaimedToDirectInjectPct,
                   set_parmReclaimedToVadosePct, ReclaimedToOutput,mydefault, tag);
                //
            }
                _ws.get_parmReclaimedToOutputPct = set_parmReclaimedToOutputPct;
                _ws.get_parmReclaimedToDirectInjectPct = set_parmReclaimedToDirectInjectPct;
                _ws.get_parmReclaimedToVadosePct = set_parmReclaimedToVadosePct;
        }
        //
        // CHANGED QUAY was WaterSim.WaterSimU _ws
         internal static void RangeCheckEffluent(WaterSimU _ws)
        {
            // default variable must be placed in the first position
            string tag = "Effluent parameters-";
            int pdefault = 0;
            for (int num = 0; num < numModeledProviders; ++num)
            {
                RangeCheckTwo(num,set_parmEffluentToVadosePct,set_parmEffluentToPowerPlantPct, pdefault, tag);
                //
            }
                _ws.get_parmEffluentToVadosePct = set_parmEffluentToVadosePct;
                _ws.get_parmEffluentToPowerPlantPct = set_parmEffluentToPowerPlantPct;
        }
        //
         // CHANGED QUAY was WaterSim.WaterSimU _ws

        internal static void RangeCheckWaterSupply(WaterSimU _ws)
        {
            // default variable must be placed in the first and second position
            string tag = "Water Supply to various: parameters-";
            int pdefault1 = 70;
            int pdefault2 = 30;
            for (int num = 0; num < numModeledProviders; ++num)
            {
                RangeCheckTwo_twoDefaults(num, set_parmWaterSupplyToResidentialPct, 
                    set_parmWaterSupplyToCIOpct,pdefault1,pdefault2, tag);
                //
            }
                _ws.get_parmWaterSupplyToResidentialPct = set_parmWaterSupplyToResidentialPct;
                _ws.get_parmWaterSupplyToCIOpct = set_parmWaterSupplyToCIOpct;
            
        }

        //
        internal static void RangeCheckTwo(int iProv, int[] one, int[] two, int mydefault, string tag)
        {
            // default has been changed
            if (-1 < one[iProv])
            {
                if (-1 < two[iProv])
                {
                    if (100 < one[iProv] + two[iProv])
                    {
                        throw new ArgumentException(tag + "Values out of range");
                    }

                }
                else
                {
                    if (100 < ((one[iProv] + two[iProv]) + 1))
                    {
                        throw new ArgumentException(tag + "Values out of range");
                    }
                }

            }
            // using default 
            {
                if (100 - mydefault < two[iProv] )
                {
                    throw new ArgumentException(tag + "  Values out of range for: " + iProv);
                }
            }
        }
        internal static void RangeCheckThree_oneDefault(int iProv, int[] one, int[] two, int[] three, int parmSetInRunInit, int WaterSimUdefault,string tag)
        {
            // output=-1, direct inject=2, vadose=3
            // default variable has been changed

                if (-1 != one[iProv])
                {
                    if (0 == one[iProv])
                    {
                        if (-1 < two[iProv])
                        {
                            if (-1 < three[iProv])
                            {
                                if (100 < two[iProv] + three[iProv])
                                {
                                    throw new ArgumentException("A " + tag + "  Values out of range for: " + iProv);
                                }
                            }
                            else
                            {
                                if (100 < two[iProv])
                                {
                                    throw new ArgumentException("A1 " + tag + "  Values out of range for: " + iProv);
                                }

                            }
                        }
                        else
                        {
                            if (100 < three[iProv])
                            {
                                throw new ArgumentException("A2 " + tag + "  Values out of range for: " + iProv);
                            }

                        }

                    }
                    else
                    {
                        if (-1 < two[iProv])
                        {
                            if (-1 < three[iProv])
                            {
                                if (100 < (parmSetInRunInit + two[iProv] + three[iProv]))
                                {
                                    throw new ArgumentException("B " + tag + "  Values out of range for: " + iProv);
                                }
                            }
                        }
                        else
                        {
                            if (-1 < three[iProv])
                            {
                                if (100 < (parmSetInRunInit + three[iProv]))
                                {
                                    throw new ArgumentException("B1 " + tag + "  Values out of range for: " + iProv);
                                }
                            }
                            else
                            {
                                if (100 < one[iProv]) //
                                {
                                    throw new ArgumentException("B2 " + tag + "  Values out of range for: " + iProv);
                                }

                            }
                        }
                    }
                }
                // one is equal to default
                else
                {
                    if (-1 < two[iProv])
                    {
                        if (-1 < three[iProv])
                        {
                            if (100 < (WaterSimUdefault + two[iProv] + three[iProv]))
                            {
                                throw new ArgumentException("C1 " + tag + "  Values out of range for: " + iProv);
                            }
                        }
                        else
                        {
                            if (100 < (WaterSimUdefault + two[iProv]))
                            {
                                throw new ArgumentException("C2 " + tag + "  Values out of range for: " + iProv);
                            }

                        }
                    }
                    else
                    {
                        if (-1 < three[iProv])
                        {
                            if (100 < (WaterSimUdefault + three[iProv]))
                            {
                                throw new ArgumentException("C3 " + tag + "  Values out of range for: " + iProv);
                            }
                        }
                    }


                }
                // 
                if (-1 != three[iProv])
                {
                    if (one[iProv] == 0 && two[iProv] == 0)
                    {
                        if (100 < three[iProv])
                        {
                            throw new ArgumentException("E " + tag + "  Values out of range for: " + iProv);
                        }
                    }
                }
                if (-1 < one[iProv] && -1 < two[iProv])
                {
                    if (100 < (one[iProv] + two[iProv]))
                    {
                        throw new ArgumentException("G " + tag + "  Values out of range for: " + iProv);
                    }
                }

                //
            //}
            //else
            //{

            //}
        }        //
        internal static void RangeCheckTwo_twoDefaults(int iProv, int[] one, int[] two, int mydefault1,int mydefault2, string tag)
        {
            // default variable has been changed
            if (-1 < one[iProv] || -1 < two[iProv])
            {
                if (-1 < one[iProv] && -1 < two[iProv])
                {
                    if (100 < (one[iProv] + two[iProv] ) )
                    {
                        throw new ArgumentException(tag + "Values out of range");
                    }

                }
                if(-1 < one[iProv] )
                {
                    if (-1 == two[iProv])
                    {
                        if (100 < (one[iProv] + mydefault2 ) )
                        {
                            throw new ArgumentException(tag + "Values out of range");
                        }
                    }
                }
                if (-1 < two[iProv])
                {
                    if (100 < (mydefault1 + two[iProv] ) )
                    {
                        throw new ArgumentException(tag + "Values out of range");
                    }
                }
            }
            // using default variable
            else
            {
                if (100 < ((mydefault1+mydefault2)+0) )
                {
                    throw new ArgumentException(tag + "  Values out of range for: " + iProv);
                }
            }
        }

        #endregion
        //
        internal enum providers
        {
            Adaman_Mutual,
            White_Tanks,
            Paradise_Valley,
            Sun_City,
            Sun_City_West,
            Avondale,
            Berneil,
            Buckeye,
            Carefree,
            Cave_Creek,
            Chandler,
            Chaparral_City,
            Surprise,
            Clearwater_Utilities,
            Desert_Hills,
            El_Mirage,
            Gilbert,
            Glendale,
            Goodyear,
            Litchfield_Park,
            Mesa,
            Peoria,
            Phoenix,
            Queen_Creek,
            Rigby,
            Rio_Verde,
            Rose_Valley,
            Scottsdale,
            Sunrise,
            Tempe,
            Tolleson,
            Valley_Utilities,
            West_End
        };

    }
}