﻿using System;
using System.Collections.Generic;
using System.Text;

// namespace: WaterSimDCDC
//
// summary:	.

namespace WaterSimDCDC
{
    internal static class WS_Strings
    {
        internal const int wsBadDataDirectory = 0;
        internal const int wsOnlyOneObject = 1;
        internal const int wsLockAfterIntialization = 2;
        internal const int wsInvalidProvider = 3;
        internal const int wsInternalRangeCheck = 4;
        internal const int wsInvalid_EModelPAram = 5;
        internal const int wsModelParamMUstBeInputBase = 6;
        internal const int wsModelParamMUstBeInputProvider = 7;
        internal const int wsUableOpenDbConnection = 8;
        internal const int wsdbConNull = 9;
        internal const int wsdbNullParameter = 10;
        internal const int wsModelParameterMissing = 11;
        internal const int wsSetGPCDError = 12;

        internal const int wsMustBeBaseParameter = 13;

        internal const int wsMustBeProviderParameter = 14;

        internal const int wsProcessInList = 15;

        internal const int wsInvalidDataTable = 16;
        
        const int NumberOfStrings = 17;
        
        /// <summary> .  </summary>
        static string[] values = new string[NumberOfStrings] {
            "Invalid Data Directory Path",
            "Only one object of WaterSim can be instatiated at time! Dispose() must be called before a WaterSim object loses scope.",
            "Simulation can not be locked until it has been initialized!",
            "Invalid Provider.",
            "Intern range check on unknown or special parameter.",
            "WaterSim API Error: Invalid eModelParam.",
            "Model Parameter must be a modelParamType.mptInputBase.",
            "Model Parameter must be a modelParamType.mptInputProvider.",
            "Unable to open oleDbConnection.",
            "DbConnection value can not be null.",
            "Method parameters can not be null.",
            "Internal Error - A Model Parameter is missing!",
            "GPCD can only be set if Demand Option is set to 4 (User Deand) first",
            "Must be a base parameter to access this type of property.",
            "Must be a provider parameter to access this type of property.",
            "Process already in the list for processing ",
            "Not a valid WaterSim_DB DataTable"

        };
        //-----------------------------------------------------------------

        /// <summary>   Valid index . </summary>
        ///
        /// <remarks>   Ray, 8/3/2011. </remarks>
        ///
        /// <param name="index">    Zero-based index of the. </param>
        ///
        /// <returns>   true if it succeeds, false if it fails. </returns>

        internal static bool Valid(int index)
        {
            return ((index>0)&(index<NumberOfStrings));
        }
        //-----------------------------------------------------------------

        /// <summary>   Gets. </summary>
        ///
        /// <remarks>   Ray, 8/3/2011. </remarks>
        ///
        /// <param name="index">    Zero-based index of the. </param>
        ///
        /// <returns>   . </returns>

        public static string Get(int index)
        {
            if (Valid(index)) return values[index];
            else return "";
        }
    }
}
